/********************************************************************
    filename: shellopn.cpp 

    ShellOpen
    
    Copyright 2002 by Joachim Schlosser <jo_shellopn@schlosser.info>
    
    At least one parameter required:
    The document's full path plus optional parameters, or any full
    URL, including the protocol identifier as http, ftp, ...

    If you find ShellOpen useful, I would be pleased with a notice.

    ShellOpen is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
********************************************************************/
#include <windows.h>
#include <windef.h>
#include <winbase.h>
#include <process.h>

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     args,
                     int       nCmdShow)
{
	try
	{
		if (strcmp(args,"")==0)
		{
			MessageBox(0,"ShellOpen
(c) 2002 by Joachim Schlosser
Opens documents without opening the application explicitly.

At least one parameter required:
The document's full path plus optional parameters, or any full
URL, including the protocol identifier as http, ftp, ...

If you find ShellOpen useful, I would be pleased with a notice.

ShellOpen is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
","About", MB_OK|MB_ICONINFORMATION);
			return -1;
		} else {
			if (
				(strncmp(args, "http:", 5)==0)	||
				(strncmp(args, "https:", 6)==0) ||
				(strncmp(args, "ftp:", 4)==0)	||
				(strncmp(args, "gopher:", 7)==0) ||
				(strncmp(args, "telnet:", 7)==0) ||
				(strncmp(args, "mailto:", 7)==0)
				)
			{
				if (spawnlp( _P_NOWAIT , "rundll32.exe", "rundll32.exe", "url.dll,FileProtocolHandler", args, NULL) == -1)
				{
					MessageBox(0,"Error in opening URL","URL open error",MB_OK|MB_ICONSTOP); 
					return -2;
				}
			} else {
				if ((int)ShellExecute(0, "open", args, NULL, NULL, SW_SHOWNORMAL) <= 32)
				{
					MessageBox(0,"Error in opening file","File open error",MB_OK|MB_ICONSTOP); 
					return -3;
				}
			}
		}
	}
	catch (...)
	{
		MessageBox(0, "Unhandled Exception.", "Exception", MB_OK|MB_ICONSTOP);
		return -4;
	}
	return 0;
}



